#!/usr/bin/env python
import rospy
from turtlesim.srv import *
from geometry_msgs.msg import PoseStamped

#callback that takes a pose, and calls the teleport absolute service to
#set the turtles position based on the pose positions
def callback(data):
   teleport_turtle(data.pose.position.x/100+6,data.pose.position.y/100+6,0) 



#code that initializes the subscriber
def turtle_follower():
   rospy.wait_for_service('turtle1/teleport_absolute')
   rospy.Subscriber("mavros/local_position/pose", PoseStamped, callback)
   rospy.spin()

if __name__ == '__main__':
    #here we set up the service, then call turtle_follower to set up the
    #subscriber
    rospy.wait_for_service('turtle1/teleport_absolute')
    try:
        teleport_turtle = rospy.ServiceProxy('turtle1/teleport_absolute',TeleportAbsolute)
        rospy.init_node('turtle_follower',anonymous=True)

    except rospy.ServiceException as e:
        print("Service call failed: %s"%e)
    turtle_follower()
